#pragma once

#include "node.hpp"
#include "points_without_bonus.hpp"
#include "student_points.hpp"
#include "user_grade_boundaries.hpp"

#include <QList>

struct UserPointConfig;
struct UserGradeConfig;

template <GradingType Grading>
struct GradeList
    : Node<UserPointConfig, UserGradeConfig, UserGradeBoundaries<Grading>,
           PointsWithoutBonus<Grading>, StudentPoints<Grading>> {
    using GradeList::Node::Node;

    void recalculate();

    QList<Grade> mGrades{};
};
