#include "points.hpp"

#include "defaults.hpp"
#include "exception.hpp"

#include <QString>
#include <QtGlobal>

Points stringToPoints(QString s) noexcept(false) {
    if (s.isEmpty() || s == "-") {
        return Points{0.};
    }

    // dynexite file might use dot or comma as decimal separator
    s.replace(',', '.');

    bool success;
    const auto res = s.toDouble(&success);
    if (success) {
        return Points{res};
    } else {
        throw DynamiteException{"Could not convert string \"" + s +
                                "\" to a number."};
    }
}

bool qFuzzyCompare(const Points p1, const Points p2) noexcept {
    return qFuzzyCompare(p1.p, p2.p);
}

bool importEpsCompare(const Points p1, const Points p2,
                      const Points maxPoints) noexcept {
    return std::abs(p1.p - p2.p) <= maxPoints.p * defaults::importEpsilon;
}
